"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _timers = require("timers");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var uuidv1 = require('uuid/v1');

var chartloader = 0;
var chartloaderAfterInit = 0;

var PieChart =
/*#__PURE__*/
function (_Component) {
  _inherits(PieChart, _Component);

  function PieChart(props) {
    var _this;

    _classCallCheck(this, PieChart);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PieChart).call(this, props));
    _this.state = {
      id: uuidv1(),
      chartloader: 0
    };
    return _this;
  }

  _createClass(PieChart, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var curobj = this;

      if (document.getElementById("googlechartscript") == null) {
        var script = document.createElement("script");
        script.id = "googlechartscript";
        script.src = "https://www.gstatic.com/charts/loader.js"; //script.async = true;

        document.body.appendChild(script);

        script.onload = function () {
          //google.charts.load("visualization", "1", {packages:["corechart"]});
          google.charts.load('current', {
            'packages': ['corechart', 'geochart']
          });
          curobj.timer = (0, _timers.setInterval)(function () {
            google.charts.setOnLoadCallback(curobj.renderChart());
          }, 50);
          curobj.setState({
            chartloader: curobj.timer
          });
        };
      } else {
        this.timer = (0, _timers.setInterval)(function () {
          curobj.renderChart();
        }, 50);
      }
    }
  }, {
    key: "renderChart",
    value: function renderChart() {
      if (this.timer != null && typeof google !== "undefined" && typeof google.visualization !== "undefined" && typeof google.visualization.arrayToDataTable != "undefined") {
        switch (this.props.chart) {
          case 'Pie':
            {
              this.renderPieChart();
              break;
            }

          case 'Area':
            {
              this.renderAreaChart();
              break;
            }

          case 'Bar':
            {
              this.renderBarChart();
              break;
            }

          case 'Bubble':
            {
              this.renderBubbleChart();
              break;
            }

          case 'Geo':
            {
              this.renderGeoChart();
              break;
            }

          default:
            {
              alert("Invalid Chart");
            }
        }
      }
    }
  }, {
    key: "renderPieChart",
    value: function renderPieChart() {
      if (typeof google.visualization.PieChart != "undefined") {
        clearInterval(this.timer._id);
        this.timer = undefined;
        var data = google.visualization.arrayToDataTable(this.props.data);
        var chart = new google.visualization.PieChart(document.getElementById(this.state.id));
        chart.draw(data, this.props.options);
      }
    }
  }, {
    key: "renderAreaChart",
    value: function renderAreaChart() {
      if (typeof google.visualization.AreaChart != "undefined") {
        clearInterval(this.timer._id);
        this.timer = undefined;
        var data = google.visualization.arrayToDataTable(this.props.data);
        var chart = new google.visualization.AreaChart(document.getElementById(this.state.id));
        chart.draw(data, this.props.options);
      }
    }
  }, {
    key: "renderBarChart",
    value: function renderBarChart() {
      if (typeof google.visualization.BarChart != "undefined") {
        clearInterval(this.timer._id);
        this.timer = undefined;
        var data = google.visualization.arrayToDataTable(this.props.data);
        var chart = new google.visualization.BarChart(document.getElementById(this.state.id));
        chart.draw(data, this.props.options);
      }
    }
  }, {
    key: "renderBubbleChart",
    value: function renderBubbleChart() {
      if (typeof google.visualization.BubbleChart != "undefined") {
        clearInterval(this.timer._id);
        this.timer = undefined;
        var data = google.visualization.arrayToDataTable(this.props.data);
        var chart = new google.visualization.BubbleChart(document.getElementById(this.state.id));
        chart.draw(data, this.props.options);
      }
    }
  }, {
    key: "renderGeoChart",
    value: function renderGeoChart() {
      if (typeof google.visualization.GeoChart != "undefined") {
        clearInterval(this.timer._id);
        this.timer = undefined;
        var data = google.visualization.arrayToDataTable(this.props.data);
        var chart = new google.visualization.GeoChart(document.getElementById(this.state.id));
        chart.draw(data, this.props.options);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          color = _this$props.color,
          children = _this$props.children;
      return _react.default.createElement("div", {
        id: this.state.id,
        style: this.props.style
      });
    }
  }]);

  return PieChart;
}(_react.Component);

var _default = PieChart;
exports.default = _default;